import os
import subprocess
import sys
import squishpyutil

from multiprocessing.managers import BaseManager

remote_port = 8989
remote_password = "MeineGeheimesPassword"

def start_server( port, password ):
    print "Listening for incoming connections..."
    mgr = BaseManager( address=( '', port ), authkey=password )
    s = mgr.get_server()
    s.serve_forever()

def os_system( command ):
    if command not in [ "DIR" ]:
        return "REMOTE SERVER ERROR: Unsupported command: %s\r\nREMOTE SERVER ERROR: Supported commands: DIR" % command

    p = subprocess.Popen(
        args=command,
        shell=True,
        stdin=subprocess.PIPE,
        stdout=subprocess.PIPE,
        stderr=subprocess.STDOUT)
    stdout, stderr = p.communicate()
    return stdout

if __name__ == "__main__":
    if "SQUISH_PREFIX" in os.environ:
        squishpyutil.remove_squish_paths_and_run_again( os.environ[ "SQUISH_PREFIX" ] )
    elif len( sys.argv ) == 1:
        BaseManager.register( "os_system", os_system )
        start_server( remote_port, remote_password )
    else:
        print "USAGE: python %s" % sys.argv[ 0 ]
